VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.ISettings
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Function ISettings_SetKey(ByVal sSection As String, ByVal sKey As String, ByVal vntValue As Variant)

    WritePrivateProfileString sSection, sKey, CStr(vntValue), App.Path & "\core.ini"

End Function
Public Function ISettings_GetKey(ByVal sSection As String, ByVal sKey As String) As String

    Dim xRet As Long
    Dim sReturnStr As String
    Dim nStringLen As Integer
  
    nStringLen = 255
    sReturnStr = String(nStringLen, Chr$(0))
  
    xRet = GetPrivateProfileString(sSection, sKey, "", sReturnStr, nStringLen, App.Path & "\core.ini")

    ISettings_GetKey = Left(sReturnStr, xRet)
  
End Function
Public Sub ISettings_DelKey(ByVal sSection As String, sKey As String)

    WritePrivateProfileString sSection, CStr(sKey), 0&, App.Path & "\core.ini"

End Sub
Public Sub ISettings_CreateSection(ByVal sSection As String)

    WritePrivateProfileString sSection, "", "", App.Path & "\core.ini"

End Sub
Public Sub ISettings_DelSection(ByVal sSection As String)

    WritePrivateProfileString sSection, 0&, 0&, App.Path & "\core.ini"

End Sub
Public Function ISettings_GetSections() As String()
    
    Dim sections() As String
    Dim textline As String
    Dim hFile As Long
    
    hFile = FreeFile
    ReDim sections(0)
    Open App.Path & "\core.ini" For Input As #hFile
    While Not EOF(hFile)
        Line Input #hFile, textline
        textline = Trim(textline)
        If Left(textline, 1) = "[" And Right(textline, 1) = "]" Then
            ReDim Preserve sections(UBound(sections) + 1)
            textline = Right(textline, Len(textline) - 1)
            textline = Left(textline, Len(textline) - 1)
            sections(UBound(sections)) = textline
        End If
    Wend
    Close #hFile
    ISettings_GetSections = sections

End Function
